package com.exner.tools.jkbikemechanicaldisasterprevention.network.strava

import com.exner.tools.jkbikemechanicaldisasterprevention.network.strava.models.StravaDetailedAthlete
import com.exner.tools.jkbikemechanicaldisasterprevention.network.strava.models.StravaSummaryActivity
import retrofit2.Call
import retrofit2.http.Body
import retrofit2.http.GET
import retrofit2.http.Headers
import retrofit2.http.POST
import retrofit2.http.Query

interface StravaApi {

    @Headers("Content-Type: application/json")
    @POST("/oauth/token")
    fun postOAuthTokenRequest(@Body oAuthRequestData: StravaOAuthRequestData): Call<StravaOAuthRequestResponse>

    @Headers("Content-Type: application/json")
    @POST("/oauth/token")
    fun postOAuthRefreshTokenRequest(@Body oAuthRefreshTokenRequestData: StravaOAuthRefreshTokenRequestData): Call<StravaOAuthRefreshTokenRequestResponse>

    @GET("/api/v3/athlete")
    fun getLoggedInAthlete(): Call<StravaDetailedAthlete>

    @GET("/api/v3/athlete/activities")
    fun getLoggedInAthleteActivities(
        @Query("before") before: Long?,
        @Query("after") after: Long?,
        @Query("page") page: Int?,
        @Query("per_page") perPage: Int?
    ): Call<List<StravaSummaryActivity>>
}
