package com.exner.tools.jkbikemechanicaldisasterprevention.network.strava

import com.exner.tools.jkbikemechanicaldisasterprevention.preferences.StravaApiTokenStorage
import okhttp3.Interceptor
import okhttp3.Response

class StravaAuthInterceptor(
    val stravaApiTokenStorage: StravaApiTokenStorage
) : Interceptor {

    override fun intercept(chain: Interceptor.Chain): Response {
        val requestBuilder = chain.request().newBuilder()

        // If token has been saved, add it to the request
        stravaApiTokenStorage.fetchStravaAccessToken()?.let { token ->
            requestBuilder.addHeader("Authorization", "Bearer $token")
        }

        return chain.proceed(requestBuilder.build())
    }
}