package com.exner.tools.jkbikemechanicaldisasterprevention.network.strava.models

import com.exner.tools.jkbikemechanicaldisasterprevention.database.entities.StravaSummaryGear
import com.squareup.moshi.Json
import com.squareup.moshi.JsonClass
import kotlinx.datetime.Instant

@JsonClass(generateAdapter = true)
data class StravaDetailedAthlete(
    @field:Json(name = "id") val id: Long?,
    @field:Json(name = "user_name") val userName: String?,
    @field:Json(name = "resource_state") val resourceState: Int?, // "2" == Summary
    @field:Json(name = "firstname") val firstName: String?,
    @field:Json(name = "lastname") val lastName: String?,
    @field:Json(name = "profile_medium") val profileMedium: String?,
    @field:Json(name = "profile") val profile: String?,
    @field:Json(name = "city") val city: String?,
    @field:Json(name = "state") val state: String?,
    @field:Json(name = "country") val country: String?,
    @field:Json(name = "sex") val gender: String?,
    @field:Json(name = "premium") val premium: Boolean?,
    @field:Json(name = "summit") val summit: Boolean?,
    @field:Json(name = "created_at") val createdAt: Instant?,
    @field:Json(name = "update_at") val updatedAt: Instant?,
    @field:Json(name = "follower_count") val followerCount: Int?,
    @field:Json(name = "friend_count") val friendCount: Int?,
    @field:Json(name = "measurement_preference") val measurementPreference: String?,
    @field:Json(name = "ftp") val ftp: Int?,
    @field:Json(name = "weight") val weight: Float?,
    @field:Json(name = "clubs") val clubs: List<StravaSummaryClub>,
    @field:Json(name = "bikes") val bikes: List<StravaSummaryGear>?,
    @field:Json(name = "shoes") val shoes: List<StravaSummaryGear>?,
)
