package com.exner.tools.jkbikemechanicaldisasterprevention.ui.jkbike.components

import androidx.lifecycle.ViewModel
import com.exner.tools.jkbikemechanicaldisasterprevention.database.KJsRepository
import dagger.hilt.android.lifecycle.HiltViewModel
import javax.inject.Inject

enum class ComponentType {
    ON_BIKE,
    ON_SHELF,
    RETIRED
}

@HiltViewModel
class ManageComponentsViewModel @Inject constructor(
    repository: KJsRepository
) : ViewModel() {

    val components = repository.observeNonRetiredComponents

    val componentsOnShelf = repository.observerShelvedComponents

    val retiredComponents = repository.observeRetiredComponents

    val bikes = repository.observeBikes

}