package com.exner.tools.jkbikemechanicaldisasterprevention.ui.strava

import androidx.lifecycle.ViewModel
import androidx.lifecycle.viewModelScope
import com.exner.tools.jkbikemechanicaldisasterprevention.preferences.StravaApiTokenStorage
import com.exner.tools.jkbikemechanicaldisasterprevention.preferences.UserPreferencesManager
import dagger.hilt.android.lifecycle.HiltViewModel
import kotlinx.coroutines.flow.SharingStarted
import kotlinx.coroutines.flow.stateIn
import javax.inject.Inject

@HiltViewModel
class StravaApiCredentialsViewModel @Inject constructor(
    userPreferencesManager: UserPreferencesManager,
    stravaApiTokenStorage: StravaApiTokenStorage
) : ViewModel() {

    val stravaApiKey = userPreferencesManager.stravaApiKey().stateIn(
        viewModelScope,
        SharingStarted.WhileSubscribed(),
        null
    )
    val stravaApiSecret = userPreferencesManager.stravaApiSecret().stateIn(
        viewModelScope,
        SharingStarted.WhileSubscribed(),
        null
    )

    val isConnected = stravaApiTokenStorage.getStravaIsConnected()
}